import * as i0 from '@angular/core';
import { Injectable, Component, NgModule } from '@angular/core';
import { Subject } from 'rxjs';
import * as i2 from '@angular/platform-browser';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';

// import { Injectable } from '@angular/core';
// import { Subject } from 'rxjs';
// export interface ToastMessage {
//   type: 'success' | 'error'| 'loading' | 'discard';
//   message: string;
// }
// @Injectable({
//   providedIn: 'root'
// })
// export class OsmToastService {
//   private toastMessages = new Subject<ToastMessage>();
//   toastMessages$ = this.toastMessages.asObservable();
//   success(message: string) {
//     this.showToast({ type: 'success', message });
//   }
//   error(message: string) {
//     this.showToast({ type: 'error', message });
//   }
//   loading(message: string) {
//     const id=this.generateId();
//     this.showToast({ type: 'loading', message});
//   }
//   private generateId() {
//     return Math.random().toString(36).substr(2, 9); 
//   }
//   private showToast(toast: ToastMessage) {
//     this.toastMessages.next(toast);
//   }
//   discard(id: string){
//     this.toasts = this.toasts.filter((t) => t.id !== id);
//   }
// }
class OsmToastService {
    constructor() {
        this.toastMessages = [];
        this.toastMessagesSubject = new Subject();
        this.toastMessages$ = this.toastMessagesSubject.asObservable();
    }
    success(message) {
        const id = this.generateId();
        this.showToast({ type: 'success', message, id });
    }
    error(message) {
        const id = this.generateId();
        this.showToast({ type: 'error', message, id });
    }
    loading(message) {
        const id = this.generateId();
        this.showToast({ type: 'loading', message, id });
        return id;
    }
    discard(id) {
        this.showToast({ type: 'discard', message: '', id });
    }
    generateId() {
        return Math.random().toString(36).substr(2, 9);
    }
    showToast(toast) {
        this.toastMessages.push(toast);
        this.toastMessagesSubject.next(toast);
        if (toast.type !== 'loading' && toast.id) {
            setTimeout(() => this.removeToast(toast.id), 3000);
        }
    }
    removeToast(id) {
        this.toastMessages = this.toastMessages.filter((toast) => toast.id !== id);
        this.toastMessagesSubject.next({ type: 'discard', message: '', id });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: OsmToastService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: OsmToastService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: OsmToastService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [] });

class OsmToastComponent {
    constructor(toastService, sanitizer) {
        this.toastService = toastService;
        this.sanitizer = sanitizer;
        this.toasts = [];
        this.successSvg = `<svg fill="#28a745" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 52 52" enable-background="new 0 0 52 52" xml:space="preserve">
  <path d="M26,2C12.7,2,2,12.7,2,26s10.7,24,24,24s24-10.7,24-24S39.3,2,26,2z M39.4,20L24.1,35.5
    c-0.6,0.6-1.6,0.6-2.2,0L13.5,27c-0.6-0.6-0.6-1.6,0-2.2l2.2-2.2c0.6-0.6,1.6-0.6,2.2,0l4.4,4.5c0.4,0.4,1.1,0.4,1.5,0L35,15.5
    c0.6-0.6,1.6-0.6,2.2,0l2.2,2.2C40.1,18.3,40.1,19.3,39.4,20z"/>
</svg>
`;
        this.errorSvg = `<svg viewBox="0 0 512 512" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
    <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
        <g id="add" fill="#dc3545" transform="translate(42.666667, 42.666667)">
            <path d="M213.333333,3.55271368e-14 C331.136,3.55271368e-14 426.666667,95.5306667 426.666667,213.333333 C426.666667,331.136 331.136,426.666667 213.333333,426.666667 C95.5306667,426.666667 3.55271368e-14,331.136 3.55271368e-14,213.333333 C3.55271368e-14,95.5306667 95.5306667,3.55271368e-14 213.333333,3.55271368e-14 Z M262.250667,134.250667 L213.333333,183.168 L164.416,134.250667 L134.250667,164.416 L183.168,213.333333 L134.250667,262.250667 L164.416,292.416 L213.333333,243.498667 L262.250667,292.416 L292.416,262.250667 L243.498667,213.333333 L292.416,164.416 L262.250667,134.250667 Z" id="Combined-Shape"></path>
        </g>
    </g>
</svg>

`;
        this.loadingSvg = `<svg viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
  <path d="M12 2V6M12 18V22M6 12H2M22 12H18M19.0784 19.0784L16.25 16.25M19.0784 4.99994L16.25 7.82837M4.92157 19.0784L7.75 16.25M4.92157 4.99994L7.75 7.82837" stroke="#007bff" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"/>
</svg>
`;
    }
    ngOnInit() {
        this.safeSuccessSvg = this.sanitizer.bypassSecurityTrustHtml(this.successSvg);
        this.safeErrorSvg = this.sanitizer.bypassSecurityTrustHtml(this.errorSvg);
        this.safeLoadingSvg = this.sanitizer.bypassSecurityTrustHtml(this.loadingSvg);
        this.toastService.toastMessages$.subscribe((toast) => {
            if (toast.type !== 'discard') {
                this.toasts.push(toast);
            }
            else {
                this.toasts = this.toasts.filter(t => t.id !== toast.id);
            }
        });
    }
    removeToast(toast) {
        this.toasts = this.toasts.filter((t) => t !== toast);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: OsmToastComponent, deps: [{ token: OsmToastService }, { token: i2.DomSanitizer }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: OsmToastComponent, selector: "osm-toast", ngImport: i0, template: `
    <div class="toast-container">
      <div *ngFor="let toast of toasts" class="toast" [ngClass]="toast.type">
        <span
          *ngIf="toast.type === 'success'"
          class="icon"
          [innerHTML]="safeSuccessSvg"
        ></span>
        <span
          *ngIf="toast.type === 'error'"
          class="icon"
          [innerHTML]="safeErrorSvg"
        ></span>
        <span
          *ngIf="toast.type === 'loading'"
          class="icon spin"
          [innerHTML]="safeLoadingSvg"
        ></span>
        <span>{{ toast.message }}</span>
      </div>
    </div>
  `, isInline: true, styles: [".toast-container{position:absolute;top:10px;left:50%;transform:translate(-50%);width:auto;max-width:400px;z-index:9999;display:flex;flex-direction:column;align-items:center;pointer-events:none;padding:0 10px}.toast{width:100%;max-width:350px;background-color:#333;color:#000;padding:10px;border-radius:5px;margin-bottom:10px;box-shadow:0 4px 6px #0000001a;opacity:0;display:flex;justify-content:center;align-items:center;transform:translateY(-20px);animation:slideIn .5s forwards;box-sizing:border-box;box-shadow:4px 4px 10px #0003,-4px -4px 8px #fff}.icon{width:20px;height:20px;margin-right:10px}.toast.success,.toast.error,.toast.loading{background-color:#fff}@keyframes slideIn{0%{opacity:0;transform:translateY(-20px)}to{opacity:1;transform:translateY(0)}}@media (max-width: 480px){.toast-container{padding:0 5px}.toast{max-width:100%}}.icon.spin{animation:spin 1s linear infinite}@keyframes spin{0%{transform:rotate(0)}to{transform:rotate(360deg)}}\n"], dependencies: [{ kind: "directive", type: i3.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: OsmToastComponent, decorators: [{
            type: Component,
            args: [{ selector: 'osm-toast', template: `
    <div class="toast-container">
      <div *ngFor="let toast of toasts" class="toast" [ngClass]="toast.type">
        <span
          *ngIf="toast.type === 'success'"
          class="icon"
          [innerHTML]="safeSuccessSvg"
        ></span>
        <span
          *ngIf="toast.type === 'error'"
          class="icon"
          [innerHTML]="safeErrorSvg"
        ></span>
        <span
          *ngIf="toast.type === 'loading'"
          class="icon spin"
          [innerHTML]="safeLoadingSvg"
        ></span>
        <span>{{ toast.message }}</span>
      </div>
    </div>
  `, styles: [".toast-container{position:absolute;top:10px;left:50%;transform:translate(-50%);width:auto;max-width:400px;z-index:9999;display:flex;flex-direction:column;align-items:center;pointer-events:none;padding:0 10px}.toast{width:100%;max-width:350px;background-color:#333;color:#000;padding:10px;border-radius:5px;margin-bottom:10px;box-shadow:0 4px 6px #0000001a;opacity:0;display:flex;justify-content:center;align-items:center;transform:translateY(-20px);animation:slideIn .5s forwards;box-sizing:border-box;box-shadow:4px 4px 10px #0003,-4px -4px 8px #fff}.icon{width:20px;height:20px;margin-right:10px}.toast.success,.toast.error,.toast.loading{background-color:#fff}@keyframes slideIn{0%{opacity:0;transform:translateY(-20px)}to{opacity:1;transform:translateY(0)}}@media (max-width: 480px){.toast-container{padding:0 5px}.toast{max-width:100%}}.icon.spin{animation:spin 1s linear infinite}@keyframes spin{0%{transform:rotate(0)}to{transform:rotate(360deg)}}\n"] }]
        }], ctorParameters: () => [{ type: OsmToastService }, { type: i2.DomSanitizer }] });

class OsmToastModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: OsmToastModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: OsmToastModule, declarations: [OsmToastComponent], imports: [CommonModule], exports: [OsmToastComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: OsmToastModule, providers: [OsmToastService], imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: OsmToastModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [OsmToastComponent],
                    imports: [CommonModule],
                    exports: [OsmToastComponent],
                    providers: [OsmToastService]
                }]
        }] });

/*
 * Public API Surface of osm-toast
 */

/**
 * Generated bundle index. Do not edit.
 */

export { OsmToastComponent, OsmToastModule, OsmToastService };
//# sourceMappingURL=osm-toast.mjs.map
